/*******************************************************
 *  Unit test for the String class
 *
 * test relational operators
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // Default contructor: empty string
   String s0;

   String s1("abcdef");
   String s2("abcdef");
   String s3("vwuxyz");

   std::cout << s1 << " == " << s2 << " = " << (s1 == s2)  << "\n";
   assert((s1 == s2) == true);
   std::cout << s1 << " == " << s3 << " = " << (s1 == s3)  << "\n";
   assert((s1 == s3) == false);

   std::cout << s1 << " != " << s2 << " = " << (s1 != s2)  << "\n";
   assert((s1 != s2) == false);
   std::cout << s1 << " != " << s3 << " = " << (s1 != s3)  << "\n";
   assert((s1 != s3) == true);

   std::cout << s1 << " <  " << s2 << " = " << (s1 < s2)  << "\n";
   assert((s1 < s2) == false);
   std::cout << s1 << " <  " << s3 << " = " << (s1 < s3)  << "\n";
   assert((s1 < s3) == true);
   std::cout << s3 << " <  " << s1 << " = " << (s3 < s1)  << "\n";
   assert((s3 < s1) == false);

   std::cout << s1 << " >  " << s2 << " = " << (s1 > s2)  << "\n";
   assert((s1 > s2) == false);
   std::cout << s1 << " >  " << s3 << " = " << (s1 > s3)  << "\n";
   assert((s1 > s3) == false);
   std::cout << s3 << " >  " << s1 << " = " << (s3 > s1)  << "\n";
   assert((s3 > s1) == true);

   std::cout << s1 << " <= " << s2 << " = " << (s1 <= s2)  << "\n";
   assert((s1 <= s2) == true);
   std::cout << s1 << " <= " << s3 << " = " << (s1 <= s3)  << "\n";
   assert((s1 <= s3) == true);
   std::cout << s3 << " <= " << s1 << " = " << (s3 <= s1)  << "\n";
   assert((s3 <= s1) == false);

   std::cout << s1 << " >= " << s2 << " = " << (s1 >= s2)  << "\n";
   assert((s1 >= s2) == true);
   std::cout << s1 << " >= " << s3 << " = " << (s1 >= s3)  << "\n";
   assert((s1 >= s3) == false);
   std::cout << s3 << " >= " << s1 << " = " << (s3 >= s1)  << "\n";
   assert((s3 >= s1) == true);

   //  Compare literal strings

   std::cout << s1 << " == " << "abcdef" << " = " << (s1 == "abcdef")  << "\n";
   assert((s1 == "abcdef") == true);
   std::cout << s1 << " == " << "vwuxyz" << " = " << (s1 == "vwuxyz")  << "\n";
   assert((s1 == "vwuxyz") == false);

   std::cout << s1 << " != " << "abcdef" << " = " << (s1 != "abcdef")  << "\n";
   assert((s1 != "abcdef") == false);
   std::cout << s1 << " != " << "vwuxyz" << " = " << (s1 != "vwuxyz")  << "\n";
   assert((s1 != "vwuxyz") == true);

   //  Compare character array variables

   const char *c2 = "abcdef";
   const char *c3 = "vwuxyz";

   std::cout << s1 << " == " << c2 << " = " << (s1 == c2)  << "\n";
   assert((s1 == c2) == true);
   std::cout << s1 << " == " << c3 << " = " << (s1 == c3)  << "\n";
   assert((s1 == c3) == false);

   std::cout << s1 << " != " << c2 << " = " << (s1 != c2)  << "\n";
   assert((s1 != c2) == false);
   std::cout << s1 << " != " << c3 << " = " << (s1 != c3)  << "\n";
   assert((s1 != c3) == true);

   //  Compare an empty string

   String empty;

   std::cout << s1 << " == " << empty << " = " << (s1 == empty)  << "\n";
   assert((s1 == empty) == false);
   std::cout << s1 << " != " << empty << " = " << (s1 != empty)  << "\n";
   assert((s1 != empty) == true);
   std::cout << s1 << " <  " << empty << " = " << (s1 <  empty)  << "\n";
   assert((s1 <  empty) == false);
   std::cout << s1 << " >  " << empty << " = " << (s1 >  empty)  << "\n";
   assert((s1 >  empty) == true);

   return 0;
}

